###############################################################################
###############################################################################
#                               Timer
###############################################################################
###############################################################################
# copyright (C) 2001 Andres Garcia Garcia - fandom@retemail.es
# Distributed under the terms of the GPL v2
###############################################################################
###############################################################################
# Version 1.0
###############################################################################
###############################################################################
# This program downloads a html url, process the file, downloads all links
# and tells you how long it took.
###############################################################################
#
# Keep in mind this program only works with version 8.1 or newer
#
# \
    exec tclsh "$0" "$@"  

if {$tcl_version<8.1} {
    puts "This program only works with Tcl 8.1 or newer"
    exit
}

source HtmlParser.tcl
package require http


proc Download {url} {

    regexp {(?:.*)(?:/)(.*)$} $url nada fileName

    if {$fileName==""} {
        set fileName index.html
    }

    set fileName [file join temp $fileName]

    set handle [open $fileName w]
    
    set token [::http::geturl $url -channel $handle]

    ::http::cleanup $token
    
    return $fileName
}

set requestedUrl [lindex $argv 0]

if {$requestedUrl==""} {
    exit
}

if {![file exists temp]} {
    file mkdir temp
}

# We start timing

set start [clock seconds]

# We download the given URL

set fileName [Download $requestedUrl]

# We get the links in the file

HtmlParser::Parsing $fileName $requestedUrl

# We download them one by one

    for {set i 1} {$i<$HtmlParser::nLinks} {incr i} {
        Download $HtmlParser::links($i,url)
    }

# We stop the timer

set finish [clock seconds]

# We print the result

puts "Time: [expr $::finish - $::start]"

# We delete the downloads

file delete -force temp

# And we leave

exit







